/*
 * 	crypto_conn.h
 *
 * Copyright (c) 2004 Evgeniy Polyakov <johnpol@2ka.mipt.ru>
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __CRYPTO_CONN_H
#define __CRYPTO_CONN_H

#include "acrypto.h"

#define CRYPTO_READ_SESSIONS			0
#define CRYPTO_REQUEST				1
#define CRYPTO_GET_STAT				2

struct crypto_conn_data {
	char 		name[SCACHE_NAMELEN];
	__u16 		cmd;
	__u16 		len;
	__u8 		data[0];
};

#ifdef __KERNEL__

int crypto_conn_init(void);
void crypto_conn_fini(void);

#endif				/* __KERNEL__ */
#endif				/* __CRYPTO_CONN_H */
