/*
 * 	crypto_user_ioctl.h
 *
 * Copyright (c) 2004 Evgeniy Polyakov <johnpol@2ka.mipt.ru>
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __CRYPTO_USER_IOCTL_H
#define __CRYPTO_USER_IOCTL_H

struct crypto_user_ioctl
{
	__u16		src_size;
	__u16		dst_size;
	__u16		key_size;
	__u16		iv_size;
	
	__u16 		operation;
	__u16 		type;
	__u16 		mode;
	__u16 		priority;
};

#define CRYPTO_USER_IOCTL_SYM		'U'
#define CRYPTO_SESSION_ALLOC		_IOW(CRYPTO_USER_IOCTL_SYM, 0, struct crypto_user_ioctl)
#define CRYPTO_SESSION_ADD		_IOR(CRYPTO_USER_IOCTL_SYM, 1, char *)
#define CRYPTO_FILL_DATA		_IOW(CRYPTO_USER_IOCTL_SYM, 2, struct crypto_user_data)


#ifdef __KERNEL__

#include <linux/ioctl.h>

#include "crypto_user.h"

struct crypto_user_ioctl_kern
{
	struct crypto_session_initializer ci;
	struct crypto_data 	data;
	struct crypto_session 	*s;

	int			scompleted;
	wait_queue_head_t 	wait;

	struct crypto_user_data	usr[4];
	void			*ptr[4];
};

int crypto_user_ioctl_init(void);
void crypto_user_ioctl_fini(void);

#endif /* __KERNEL__ */
#endif /* __CRYPTO_USER_IOCTL_H */
